using System;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;

namespace FastGraphics
{
    public class DrawBox : PictureBox
    {
        public DrawBox( int width, int height ) : base()
        {
            this.BorderStyle = BorderStyle.None;
            this.Size = new Size( width, height );
            this.Image = new Bitmap( width, height, System.Drawing.Imaging.PixelFormat.Format32bppPArgb );
        }

        public void SetImage( Image newImage )
        {
            Rectangle copyRect = new Rectangle( 0, 0, this.Image.Size.Width, this.Image.Size.Height );

            BitmapData destData = ( ( Bitmap ) this.Image ).LockBits( copyRect, ImageLockMode.WriteOnly, PixelFormat.Format32bppPArgb );
            BitmapData srcData = ( ( Bitmap ) newImage ).LockBits( copyRect, ImageLockMode.ReadOnly, PixelFormat.Format32bppPArgb );

            IntPtr ptrSrc = srcData.Scan0;
            IntPtr ptrDst = destData.Scan0;

            int imageSize = newImage.Size.Height * newImage.Size.Width * 4;
            Win32Native.CopyMemory( ptrDst, ptrSrc, imageSize );

            ( ( Bitmap ) this.Image ).UnlockBits( destData );
            ( ( Bitmap ) newImage ).UnlockBits( srcData );

            this.Invalidate();
        }
    }
}
